! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module dselect_mod

  use Dal
  use Param

  implicit none

  real(single) :: x0 = -1, x1 = 1
  real(single) :: y0 = -1, y1 = 1

contains

  subroutine dselect

    type(DatasetT) :: set
    type(TableT) :: tab
    type(ColumnT) :: xCol, yCol, selectedCol
    integer(int16), dimension(:), pointer :: selected
    real(single), dimension(:), pointer :: x, y
    integer ix

    set = dataSet(stringParameter("set"),Modify)

    tab = table(set,stringParameter("table"))

    xCol = column(tab,stringParameter("x"),Read)
    x => real32Data(xCol)
    yCol = column(tab,stringParameter("y"),Read)
    y => real32Data(yCol)

    selectedCol = column(tab,stringParameter("selected"),Modify)
    selected => int16Data(selectedCol)

    do ix=0,numberOfRows(tab)-1
      if (x(ix) < x0 .or. x(ix) > x1 .OR. y(ix) < y0 .OR. y(ix) > y1) then
        selected(ix) = 0
      end if
    end do

    call release(selectedCol)
    call release(set)

  end subroutine dselect

end module dselect_mod
